/*
 * (c)Copyright <a href="http://www.esup-portail.org">ESup-Portail 2004</a><br>
 * @author <a href="mailto:olivier.ziller@univ-nancy2.fr">Olivier Ziller</a><br>
 * @version 1.0<br>
 */ 
package org.esupportail.portal.utils.channels.plugins;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import org.esupportail.portal.utils.channels.Action;
import org.esupportail.portal.utils.channels.ActionParam;
import org.esupportail.portal.utils.channels.FrameWorkException;
import org.esupportail.portal.utils.channels.MainChannel;
import org.esupportail.portal.utils.channels.SubChannel;
import org.jasig.portal.PortalException;
import org.jasig.portal.groups.IEntity;
import org.jasig.portal.groups.IGroupMember;
import org.jasig.portal.security.IPerson;
import org.jasig.portal.services.GroupService;
import org.jasig.portal.services.LogService;

/**
 * Todo<br>
 * <br>
 * Ce plug-in ajoute une page qui permet d'afficher un message qui dit que la fonctionnalit reste  dvelopper<br>
 * Utile pour mettre en place rapidement le squelette d'une application avec toutes ses actions mmes si elles
 * ne sont pas encore dveloppes<br> 
 * <br>
 * (c)Copyright <a href="http://www.esup-portail.org">ESup-Portail 2004</a><br>
 * @author <a href="mailto:olivier.ziller@univ-nancy2.fr">Olivier Ziller</a>
 * @version 1.0
 * 
 */
public class RestrictedAction extends SubChannel {

	static private String plugName = "plug.esup.restrictedAction";
	
	
	
	/**
	 * Constructeur
	 * @param main
	 */
	public RestrictedAction(MainChannel main) {
		super(main);
	}
	
		 
	/**
	 * Mthode statique qui permet d'enregistrer le plug-in Todo dans la liste des actions d'une channel
	 * 
	 * @param main Channel principale de l'application
	 */
	public static void register(MainChannel main) {
		Action action = new Action();
		
		action.setName(plugName);
		action.setClassname(RestrictedAction.class.getName());
		action.setXslfile("access.xsl");
		action.setLogLevel(main.getConfigActions().getLogLevel());
		main.getConfigActions().getActions().put(action.getName(), action);
	}
	
	public static boolean filterAccess(MainChannel main,String currentAction,HashMap mapping) throws PortalException {
		return filterAccess(main,currentAction,mapping, true);
	}
	/**
	 * Mthode statique qui permet d'afficher la page du plug-in
	 * 
	 * @param ...
	 */
	public static boolean filterAccess(MainChannel main,String currentAction,HashMap mapping,boolean allowWithoutGroupSpecification) throws PortalException {
		LogService.log(LogService.INFO,plugName+" : Access reserve");
		ActionParam paramGroup = main.getActionParam(currentAction,plugName);
		
		/*Si aucun groupe n'est prcis dans la configuration*/
		if (paramGroup==null){
			return allowWithoutGroupSpecification;
		}
		
		List listGroup = paramGroup.getValues();
		
		if (main.getStaticData().get(plugName)!=null){
			LogService.log(LogService.INFO,plugName+" : filterAccess start mini scan");
	    	Iterator j = listGroup.iterator();
			/*... on recherche la cl*/
			while(j.hasNext()) {  
				String localNameGroup = (String)j.next();
				if (localNameGroup.equals(main.getStaticData().get(plugName))){
			    	LogService.log(LogService.INFO,plugName+" : groupe utilise : "+main.getStaticData().get(plugName));
			    	return true;
		        }
			}
			return false;
		}
		
		LogService.log(LogService.INFO,plugName+" : filterAccess start scan");
    	
		
		
			
		
		IEntity user = null;
		String login = (String)main.getStaticData().getPerson().getAttribute(IPerson.USERNAME);
		user = GroupService.getEntity(login, org.jasig.portal.security.IPerson.class);  
	    
		
		
 	  	  if(user != null) {  
	           Iterator groupsTest;
	           
	            groupsTest = user.getAllContainingGroups();
	            
	            
				/*Parcours des groupes de la personne connecte*/
				while(groupsTest.hasNext()) {  
					IGroupMember groupTmp = (IGroupMember)groupsTest.next(); 
	              
					Iterator j = listGroup.iterator();
					/*... on recherche la cl*/
					while(j.hasNext()) {  
						String localNameGroup = (String)j.next();
						if (mapping.get(localNameGroup).equals(groupTmp.getKey())){
					    	LogService.log(LogService.INFO,plugName+" : groupe trouve : "+groupTmp.getKey()+ " ("+localNameGroup+")");
					    	main.getStaticData().put(plugName,localNameGroup);
					    	return true;
				        }
					}
				}   
				
				LogService.log(LogService.INFO,plugName+" : aucun groupe trouve");
		   		
		   		return false;
	      }  
	      else {  
	           LogService.log(LogService.ERROR,plugName+" : Utilisateur " + login + " inexistant");  
	           //throw new FrameWorkException("Utilisateur " + login + " inexistant");
	           return false;
	      }
	}

	/**
	 * Positionnement du XML pour le plug-in
	 * 
	 * @return toujours Boolean.TRUE
	 */
	public Boolean setXML() throws FrameWorkException {
		return Boolean.TRUE;
	}

}